unit usbdefs;

interface

{tsr vars}
var nHandler_Installed:word;
var wSegment:WORD;
var wOffset:WORD;
var se1,so1:word;


{  ;----------------------------------------------------------------------------
  ;Error Codes Returned by Int 14h Requests
  ;----------------------------------------------------------------------------
}

const  I14RErrNone           =$0000;{No Error}
const  I14RErrResources      =$0001;{Insufficient Resources/Memory}
const  I14RErrHostHardware   =$0002;{Unknown/Hardware Problem with Host}
const  I14RErrReqTypeNoSupt  =$0003;{Request Type recognized, but not Supported}
const  I14RErrRequestType    =$0011;{Invalid Request Type}
const  I14RErrFlags          =$0012;{Invalid Flags}
const  I14RErrHostIndex      =$0013;{Invalid Host Index}
const  I14RErrDeviceAddress  =$0014;{Invalid Device Address}
const  I14RErrHubAddress     =$0014;{Invalid Hub Address}
const  I14RErrEndPoint       =$0015;{Invalid EndPoint}
const  I14RErrHubPort        =$0015;{Invalid Hub Port}
const  I14RErrAltIntf        =$0015;{Invalid Alternate Interface}
const  I14RErrConfigValue    =$0016;{Invalid Configuration Value}
const  I14RErrCloseID        =$0016;{Invalid Closure ID}
const  I14RErrDataX          =$0016;{Invalid DataX Value}
const  I14RErrInterfaceNum   =$0017;{Invalid Interface Number}
const  I14RErrSearchIndex    =$0018;{Invalid Search Index}
const  I14RErrVendorProdID   =$0019;{Invalid Vendor ID}
const  I14RErrDvcIntf        =$001A;{Invalid Device/Interface value}
const  I14RErrRequestHandle  =$001B;{Invalid Request Handle}
const  I14RErrPeriodicity    =$001C;{Invalid Periodicity}
const  I14RErrBeepFrequency  =$001C;{Invalid Beep Frequency}
const  I14RErrTimeOut        =$001D;{Invalid Timeout}
const  I14RErrDataAddress    =$001E;{Invalid Data Address}
const  I14RErrDataSize       =$001F;{Invalid Data Size (Low Speed <= 8)}
const  I14RErrCallBackAddr   =$0021;{Invalid Call Back Address}
const  I14RErrLCRtnCode      =$0021;{Invalid Large Call Return Code}
const  I14RErrUserPktID      =$0022;{Invalid User Pkt ID (matches on unregistry)}
const  I14RErrSetupReqData   =$0023;{Invalid Setup Request Data}
const  I14RErrFrameTiming    =$0024;{Invalid Frame Timing}
const  I14RErrFrameIndex     =$0024;{Invalid Frame Index}
const  I14RErrIsochArray     =$0025;{Invalid Entry in Isoch Array Data}
const  I14RErrHostHalted     =$0031;{Host is Halted/Suspended}
const  I14RErrIntfNotFound   =$0032;{Interface not found (on FindIntf/RegIntf)}
const  I14RErrIntfInConfig   =$0033;{Interface already beging Configured}
const  I14RErrIntfAlreadyReg =$0034;{Interface already Registered}
const  I14RErrHostCallInUse  =$0035;{Host Run/Stop/etc. already running}
const  I14RErrNoPortPower    =$0036;{Per-Port-Power not Supported by Hub}
const  I14RErrAlreadyBeeping =$0037;{Another Beep Request is already being handled}
const  I14RErrDebugMode      =$0041;{Tried to Single Step with No Debug Mode}
const  I14RErrTimingOwned    =$0051;{Problem with Frame Timing Owner}
const  I14RErrTimingLimit    =$0052;{Frame Timing is already at the Limit}
const  I14RErrTmgChgInProg   =$0053;{Timing Change already in progress}



{  ;----------------------------------------------------------------------------
  ;Special Codes
  ;----------------------------------------------------------------------------
 }
const  No  =  0 ;{Miscellaneous Yes/No tests}
const  Yes = -1 ;{      "        "  "    "}
{
  ;----------------------------------------------------------------------------
  ;Bit masks in the CPU Flags Register
  ;----------------------------------------------------------------------------
}
const  CarryFlag  =$0001 ;{Carry Flag}
const   ParityFlag =$0004 ;{Parity Flag}
const   AuxFlag    =$0010 ;{Auxiliary Flag}
const   ZeroFlag   =$0040 ;{Zero Flag}
const   SignFlag   =$0080 ;{Sign Flag}
const   TrapFlag   =$0100 ;{Trap Flag}
const   IntFlag    =$0200 ;{Interrupt Flag}
const   DirFlag    =$0400 ;{Direction Flag}
const   OFFlag     =$0800 ;{Overflow Flag}


{  ;----------------------------------------------------------------------------
  ;Special CPU OpCodes we need to concern ourselves with
  ;----------------------------------------------------------------------------
}
const  OpCodeIntXX    =$0CD ;{Int XX}
const   OpCodeRETF     =$0CB ;{RETF}
const   OpCodeJMPShort =$0EB ;{JMP Short (+128/-127 bits max)}

{
;==============================================================================
;CONsole/Screen Related
;==============================================================================
=$
 ;----------------------------------------------------------------------------
  ;Special ASCII Characters
  ;----------------------------------------------------------------------------}
const   Tab       =$9 ;{Tab}
const   LF        =$10 ;{Line Feed}
const   FormFeed  =$12 ;{FormFeed}
const   CR        =$13 ;{Carriage Return}
const   EOF       =$26 ;{End-of-File     }
const   Quote2    =$34 ;{Double quote   }
const   Quote1    =$39 ;{Single quote  }
const   BackSlash =$92 ;{BackSlash (\)}

  {---------------------------------------------------------------------------- }
  {Special Keys that can be pressed during Pause routine                         }
  {----------------------------------------------------------------------------}
  CtrlC  =$3 ;{Control-C Keystroke}
  Escape =$27 ;{Escape Keystroke}

 {
;{==============================================================================
;DOS Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;;Minimum DOS Version required to use this program
  ;----------------------------------------------------------------------------}
  MinDOSVer =$0300;

{  ;----------------------------------------------------------------------------
  ;DOS Memory Allocation Strategies
  ;----------------------------------------------------------------------------}
const   StrategyLowFirst     =$00 ;{First Fit, Low Memory Only }
const   StrategyLowBest      =$01 ;{Best Fit, Low Memory Only }
const   StrategyLowLast      =$02 ;{Last Fit, Low Memory Only}
  {For DOS 3&4, anything >2 is Last Fit Low Memory}
  {Below are for DOS 5+ Only}
const   StrategyHighFirst    =$40 ;{First Fit, High Memory Only }
const   StrategyHighBest     =$41 ;{Best Fit, High Memory Only }
const   StrategyHighLast     =$42 ;{Last Fit, High Memory Only}
const   StrategyHighLowFirst =$80 ;{First Fit, Try High Memory then Low Memory }
const   StrategyHighLowBest  =$81 ;{Best Fit, Try High Memory then Low Memory }
const   StrategyHighLowLast  =$82 ;{Last Fit, Try High Memory then Low Memory}



{--------------------------------------------------------------------------}
{ ErrorLevels returned to DOS Prompt}
{--------------------------------------------------------------------------}
const ErLvlNoError =0 ;{No Error}
const ErLvlEnviron =1 ;{Environment variable error}
const ErLvlCmdLine =2;{Command-line error}
const ErLvlNoInt14 =3 ;{Compatible USB Driver not installed}


{--------------------------------------------------------------------------}
{ Standard DOS "hard-coded" Device Handles}
{--------------------------------------------------------------------------}
const StdInHandle  =0 ;{tStandard Input}
const StdOutHandle =1;{Standard Output}
const StdErrHandle =2 ;{Standard Error}
const StdAuxHandle =3 ;{Standard Auxiliary (COM1)}
const StdPrnHandle =4 ;{Standard Printer (LPT1)}


{--------------------------------------------------------------------------}
{ PSP Segment Offsets}
{--------------------------------------------------------------------------}
const PSPParentPSP   =$16 ;{Offset in PSP of Parent PSP Segment}
const PSPEnvironment =$2C ;{Offset in PSP of Environment Segment}


{--------------------------------------------------------------------------}
{ Codes returned by INT 21h, Function 4400h (Get Device Information)}
{--------------------------------------------------------------------------}
  {If bit 7 is Set (is a Device):
const DvcInfoIsStdIn    =$0001 ;{STDIN}
const DvcInfoIsStdOut   =$0002 ;{STDOUT}
const DvcInfoIsNUL      =$0004 ;{NUL}
const DvcInfoIsClock    =$0008 ;{CLOCK$}
const DvcInfoInt29h     =$0010 ;{Uses Int 29h (Special Device)}
const DvcInfoBinary     =$0020 ;{Binary (Raw) Mode}
const DvcInfoEOF        =$0040 ;{EOF on Input}
const DvcInfoIsDevice   =$0080 ;{Is a Device (not a File)}
const DvcInfoKEYB       =$0100 ;{Unknown (set by DOS 6.2x KEYB program)}
const DvcInfoOpenClose  =$0800 ;{Supports Open/Close calls}
const DvcInfoOutputBusy =$2000 ;{Supports Output until Busy}
const DvcInfoIOCTL      =$4000 ;{Can process IOCTL requests (Func 4402h)}

  {If bit 7 is Clear (is a File):
const DvcInfoDriveMask    =$003f ;{Drive number (0 = A:)}
const DvcInfoNotWritten   =$0040 ;{File not been written (Dirty Buffer)}
const DvcInfoInt24h       =$0100 ;{Generate Int 24h on Errors (DOS 4 only)}
const DvcInfoNotRemovable =$0800 ;{Media Not Removable}
const DvcInfoNoDateTime   =$4000 ;{Don't update File Date/Time (DOS 3.0+)}
const DvcInfoRemote       =$8000 ;{File is Remote (DOS 3.0+)}



{;==============================================================================
;Joystick BIOS Functions Related (Int 15h)
;==============================================================================
   ;----------------------------------------------------------------------------
  ;INT 15h Subfunction (in AH) for Joystick Calls
  ;----------------------------------------------------------------------------
 }
const  Int15JoyStickCall = $84;

  {;----------------------------------------------------------------------------
  ;INT 15h Error Codes (returned in AH)
  ;----------------------------------------------------------------------------
  }
const  I15ErrInvalidCmd = $80 ;{Invalid Command}
const  I15ErrFuncNoSupt = $86 ;{Function not Supported}


 {
  ;----------------------------------------------------------------------------
  ;Maximum number of Control Entities we can have on a Joystick
  ;A "Control Entity" is a contiguous series of Buttons or Sliders or Axes
  ;  in the USB Report.  For example, there may be two or three "groups"
  ;  of Buttons in different places in the Report.
  ;There are so many different kinds of controls that can be on a joystick
  ;  and so many different formats that the data can come in, that we need
  ;  a highly-flexible way to handle it all.
  ;----------------------------------------------------------------------------
}
const  MaxControls = 16;
   {
  ;----------------------------------------------------------------------------
  ;Maximum Control Index Number in Translation Table
  ;----------------------------------------------------------------------------
  }
const  MaxXlatIndex = 99;
 {
  ;----------------------------------------------------------------------------
  ;Temporary Bit-masks needed while Cooking ThrustMaster Coordinates
  ;Cooking ThrustMaster coordinates is complicated, since we are converting
  ;  8 directions into 4, and some of the coordinates can be bad (0).
  ;----------------------------------------------------------------------------
}
const  XInvalid =$01 ;{X Direction = 0}
const  XLeft    =$04 ;{X Direction = Left}
const  XRight   =$08 ;{X Direction = Right}
const  YInvalid =$10 ;{Y Direction = 0 }
const  YUp      =$40 ;{Y Direction = Up}
const  YDown    =$80 ;{Y Direction = Down}

 {
;==============================================================================
;Game Port Related
;==============================================================================
}
const  MinPort = $0200 ;{Minimum Game Port I/O Address}
const  MaxPort = $020F ;{Maximum Game Port I/O Address}



{
;==============================================================================
;USB Related
;==============================================================================

  ;----------------------------------------------------------------------------
  ;Maximum number of Devices we can control
  ;----------------------------------------------------------------------------
  }
  MaxDevices =$8;

  {;----------------------------------------------------------------------------
  ;Maximum number of entries in Bad (incompatible) Device Table
  ---------------------------------------------------------------------------- }
 const MaxBadDevices =$12;

 { ;----------------------------------------------------------------------------
  ;Maximum number of Raw bytes we will allow to be returned by USB Joystick
  ;----------------------------------------------------------------------------
}
const MaxJDataSize =$32;

{  ;----------------------------------------------------------------------------
  ;General
  ;----------------------------------------------------------------------------}
const  Int14RequestSize =$64 ;{Size of Int 14h USB Request Data Structure}

  {;----------------------------------------------------------------------------
  ;Maximum Descriptor Sizes
  ;NOTE: MaxDescriptorSize must be big enough to include all Config,
  ;        Interface, End-Point, and any Class-specific Descriptors
  ;        that may be included with any multiple-interface Device.
  ;      Audio and Video Interface Devices, for example, generally
  ;        include an HID Interface to further "describe" the Device.
  ;        Since we don't know ahead of time whether the HID Interface
  ;        is a Joystick/GamePad or not (and it usually isn't with
  ;        and Audio or Video Interface Device), we have to download
  ;        the entire set of Descriptors and decipher them before
  ;        we can tell whether we should control it or not.
  ;      The Descriptor sizes for Audio and Video Interface devices
  ;        are usually VERY long, much longer than "normal" devices.
  ;        The standard "Get Configuration" Request downloads all of
  ;        the Class-specific Descriptors in addition to the general
  ;        Descriptors, and Audio and Video Interface Devices can have
  ;        a LOT of Class-Specific Descriptors.
  ;      I wish the designers of the Audio and Video Interface Specs
  ;        would have done what the HID designers did, and didn't
  ;        include ALL of the Class-specific data along with the general
  ;        Device data.
  {;----------------------------------------------------------------------------}
const  MaxDescriptorSize =$800 ;{Max size of Device/Config/HID Descriptor}
const  MaxReportSize     =$600 ;{Max size of Report Descriptor}

{  {;----------------------------------------------------------------------------
  ;USB Descriptor Types
  {;----------------------------------------------------------------------------}

  DescrTypeDevice    =$01;{Device}
  DescrTypeConfig    =$02;{Configuration}
  DescrTypeString    =$03;{String}
  DescrTypeInterface =$04;{Interface}
  DescrTypeEndPoint  =$05;{EndPoint}
  DescrTypeDvcQual   =$06;{Device Qualifier}
  DescrTypeOtherSpd  =$07;{Other Speed Configuration}
  DescrTypeIntfPower =$08;{Interface Power}
  DescrTypeOnTheGo   =$09;{On-the-Go}
  DescrTypeDebug     =$0A;{Debug}
  DescrTypeIntfAssoc =$0B;{Interface Association}
  {;Types 12 - 17 (0Ch - 11h) are added for Wireless USB}
  DescrTypeWSecurity =$0C;{Wireless USB Security}
  DescrTypeWKey      =$0D;{Wireless USB Key}
  DescrTypeWEncrType =$0E;{Wireless USB Encryption Type}
  DescrTypeWBOS      =$0F;{Wireless USB Binary-device Object Store}
  DescrTypeWDvcCap   =$10;{Wireless USB Device Capability}
  DescrTypeWEndPtCmp =$11;{Wireless USB Endpoint Companion}

  {;HID Class-Specific Descriptor Types}
  DescrTypeHID         =$21;{Human Interface Device}
  DescrTypeHIDReport   =$22;{Report (from HID)}
  DescrTypeHIDPhysical =$23;{Physical Descriptor (from HID)

  {;----------------------------------------------------------------------------  }
{  ;Values in SRRequest for HID Devices                                           }
  {;----------------------------------------------------------------------------}
  HIDRQGetReport   =$1 ;{Get Report}
  HIDRQGetIdle     =$2 ;{Get Idle Factor    }
  HIDRQGetProtocol =$3 ;{Get Protocol Type }
  HIDRQSetReport   =$9 ;{Set Report       }
  HIDRQSetIdle     =$10 ;{Set Idle Factor}

  {;----------------------------------------------------------------------------  }
{  ;Data for GetReport/SetReport                                                  }
  {;----------------------------------------------------------------------------}
  HIDReportTypeNone    =$0 ;{None             }
  HIDReportTypeInput   =$1 ;{Input             }
  HIDReportTypeOutput  =$2 ;{Output             }
  HIDReportTypeFeature =$3 ;{Feature}

  {;----------------------------------------------------------------------------
{  ;USB-Defined Device and Interface Classes, SubClasses, and Protocols}
  {;----------------------------------------------------------------------------}
  DvcClassNone     =$0 ;{Device Class = None}
  DvcSubClassNone  =$0 ;{Device SubClass = None}
  DvcProtocolNone  =$0 ;{Device Protocol = None}
  IntfClassHID     =$3 ;{Interface Class = HID (Human Interface Device)}
  IntfSubClassNone =$0 ;{Interface SubClass = None}
  IntfProtocolNone =$0 ;{Interface Protocol = None}


  {;---------------------------------------------------------------------------- }
{  ;{Statuses sent by Host to USB Device Owners}
  {;----------------------------------------------------------------------------
  ;{Device Connect/Disconnect                   }
  OwnerCallNewDvc   =$0001;{A new Matching Device has been attached}
  OwnerCallDvcDisc  =$0002;{Registered Device has been disconnected}
  OwnerCallDvc0Disc =$0003;{Matching Unregistered Device Disconnected}
  OwnerCallDontLook =$0007;{Stop Looking for New Devices for ~5 seconds}
  {Device Enable/Disable/Reset/Suspend/Resume/Power}
  OwnerCallDvcEnable   =$0008;{Device Enabled}
  OwnerCallDvcDisable  =$0009;{Device Disabled}
  OwnerCallDvcReset    =$000A;{Device Resetting}
  OwnerCallDvcSuspend  =$000B;{Device Suspended }
  OwnerCallDvcResume   =$000C;{Device Resumed    }
  OwnerCallDvcPwrOn    =$000D;{Device Power On    }
  OwnerCallDvcPwrOff   =$000E;{Device Power Off    }
  OwnerCallDvcPwrReset =$000F;{Device Power Reset   }
  {Host Connect/Disconnect/Error                     }
  OwnerCallNewHost     =$0011;{A new Host Driver has been Installed}
  OwnerCallHostDisc    =$0012;{An existing Host Driver has been Uninstalled}
  OwnerCallHostHWErr   =$0017;{Host System/Processor Error (Host will Reset)}
  {;Host Run/Stop/Reset/Suspend/Resume}
  OwnerCallHostRun     =$0018;{Host Running}
  OwnerCallHostStop    =$0019;{Host Stopped }
  OwnerCallHostReset   =$001A;{Host Reset    }
  OwnerCallHostSuspend =$001B;{Host Suspended }
  OwnerCallHostResume  =$001C;{Host Resumed    }
  OwnerCallHostDebug   =$001D;{Host in Debug Mode}
  OwnerCallHostSST     =$001E;{Host Single-Stepped}
  {;Timing Changes}
  OwnerCallTimingChg   =$0021;{Timing Change on Host}
  {;Upstream Device Changes}
  OwnerCallDvcDiscUS     =(OwnerCallDvcDisc OR $0080)     ;{Dvc Disc Upstream}
  OwnerCallDvcEnableUS   =(OwnerCallDvcEnable OR $0080)   ;{Dvc Enable Upstream}
  OwnerCallDvcDisableUS  =(OwnerCallDvcDisable OR $0080)  ;{Dvc Disable Upstream}
  OwnerCallDvcResetUS    =(OwnerCallDvcReset OR $0080)    ;{Dvc Reset Upstream}
  OwnerCallDvcSuspendUS  =(OwnerCallDvcSuspend OR $0080)  ;{Dvc Suspend Upstream}
  OwnerCallDvcResumeUS   =(OwnerCallDvcResume OR $0080)   ;{Dvc Resume Upstream}
  OwnerCallDvcPwrOnUS    =(OwnerCallDvcPwrOn OR $0080)    ;{Dvc PwrOn Upstream}
  OwnerCallDvcPwrOffUS   =(OwnerCallDvcPwrOff OR $0080)   ;{Dvc PwrOff Upstream}
  OwnerCallDvcPwrResetUS =(OwnerCallDvcPwrReset OR $0080) ;{Dvc PwrReset Upstream}


{;==============================================================================
;USB Report Descriptor Related
;  HID Reports Start with a 1-byte Tag, followed by 0 or more bytes of Data
;  Bits 0-1 are actual size (0-3 bytes of data following the Tag)
;  Bits 2-3 are Tag Type: 0h = Main, 4h = Global, 8h = Local, Ch = Reserved
;==============================================================================
 }
  {;----------------------------------------------------------------------------  }
{  ;Miscellaneous                                                                 }
  {;----------------------------------------------------------------------------}
  RptTagLongData =$00FC;{Long Data Item (more than 3 bytes)
                           ;Lower 2 bits are always 10h (Size of 2)
                           ;Next byte is Actual Data Size (0-255)
                           ;Next Byte is Tag (Description)
                           ;Followed by up to 255 bytes of "real" data

  {;----------------------------------------------------------------------------
  ;Main
  ;----------------------------------------------------------------------------
  }
  RptTagInput              =$80;{Input}
  RPtTagOutput             =$90;{Output}
  RptTagFeature            =$0B0;{Feature}
    {;These apply to Input, Output, and Feature}
    RptMainIOFConstant     =$01;{Constant}
     RptMainIOFData        =$00;{ Data}
    RptMainIOFVariable     =$02;{Variable}
     RptMainIOFArray       =$00;{ Array}
    RptMainIOFRelative     =$04;{Relative}
     RptMainIOFAbsolute    =$00;{ Absolute}
    RptMainIOFWrap         =$08;{Wrap      }
     RptMainIOFNoWrap      =$00;{ No Wrap   }
    RptMainIOFNonLinear    =$10;{Non-Linear  }
     RptMainIOFLinear      =$00;{ Linear      }
    RptMainIOFNoPrefer     =$20;{No Preferred State}
     RptMainIOFPrefer      =$00;{ Preferred State}
    RptMainIOFNull         =$40;{Null State       }
     RptMainIOFNoNull      =$00;{ No Null State    }
    RptMainIOFVolatile     =$80;{Volatile           }
     RptMainIOFNonVolatile =$00;{ Non-Volatile       }
    RptMainIOFBuffered     =$100;{Buffered Bytes      }
     RptMainIOFBitField    =$000;{ Bit-Field           }

  RptTagCollection         =$0A0;{Collection             }
    RptMainColPhysical     =$00;{Physical (Group of Axes) }
    RptMainColApplication  =$01;{Application (Mouse/Keyboard)}
    RptMainColLogical      =$02;{Logical (interrelated Data)}

  RptTagEndCollection      =$0C0;{End Collection}



{}
{ Int 14 Request consts}
{ They go in the various Int 14h Request Structure Parameters,}
{   or are sent as return values (error codes & such).}
{}

{--------------------------------------------------------------------------}
{ INT 14h USB Functions}
{--------------------------------------------------------------------------}
const I14BXInput        =$5553 ;{'US'}
const I14CXInput        =$4221 ;{'B!'}

const I14AXInstallCheck =$5000 ;{Installation Check Function}
const I14AXDoFunction   =$5001 ;{All other functions}

{//--------------------------------------------------------------------------
//Int 14h Request Types
//--------------------------------------------------------------------------}
const   I14RRTHostClass       =$00 ;{Host/System/OS Class}
const   I14RRTGetHostSWInfo   =$01 ;{Get Host Software Info}
const   I14RRTGetHostHWInfo   =$02 ;{Get Host Hardware Info}
const   I14RRTGetHostVendInfo =$03 ;{Get Host Vendor Info}
const   I14RRTGetHostStatus   =$04 ;{Get Current Host Status}
const   I14RRTHostRun         =$08 ;{Start/Run/Resume Host}
const   I14RRTHostStop        =$09 ;{Stop Host}
const   I14RRTHostReset       =$0A ;{Reset Host}
const   I14RRTHostSuspend     =$0B ;{Global Suspend Host}
const   I14RRTHostResume      =$0C ;{Force Global Resume on Host}
const I14RRTTimingClass       =$10 ;{Frame Timing Class}
const   I14RRTRegTmgOwner     =$11 ;{Register as Timing Owner}
const   I14RRTUnRegTmgOwner   =$12 ;{UnRegister as Timing Owner}
const   I14RRTIncTiming       =$13 ;{Increment (Slow Down) Frame Timing}
const   I14RRTDecTiming       =$14 ;{Decrement (Speed Up) Frame Timing}
const   I14RRTChangeTiming    =$15 ;{Change Frame Timing (by Large Amount)}
const I14RRTHubClass          =$20 ;{Hub Class}
const   I14RRTGetDvcHubInfo   =$21 ;{Get Hub Info for Device}
const   I14RRTNewDvcConn      =$24 ;{Hub has Detected new Device}
const   I14RRTDvcDisc         =$25 ;{Device has been Disconnected}
const   I14RRTSendHubChar     =$27 ;{Send Hub Characteristics to Host}
const   I14RRTEnableHubPort   =$28 ;{Enable Device given Hub & Port}
const   I14RRTDisableHubPort  =$29 ;{Disable Device given Hub & Port}
const   I14RRTResetHubPort    =$2A ;{Reset Device given Hub & Port}
const   I14RRTSuspendHubPort  =$2B ;{Suspend Device given Hub & Port}
const   I14RRTResumeHubPort   =$2C ;{Resume Device given Hub & Port}
const   I14RRTPwrOnHubPort    =$2D ;{Power On Device given Hub & Port}
const   I14RRTPwrOffHubPort   =$2E ;{Power Off Device given Hub & Port}
const   I14RRTPwrResetHubPort =$2F ;{Power Reset Device given Hub & Port}
const I14RRTTPowerClass       =$30 ;{Power Class}
const   I14RRTGetDvcPowerInfo =$31 ;{Get Power Info for Device}
const   I14RRTPwrOnDevice     =$3D ;{Power On Device given Dvc Addr}
const   I14RRTPwrOffDevice    =$3E ;{Power Off Device given Dvc Addr}
const   I14RRTPwrResetDevice  =$3F ;{Power Reset Device given Dvc Addr}
const I14RRTDeviceClass       =$40 ;{Device Class}
const   I14RRTGetDvcClassInfo =$41 ;{Get Device Class Info}
const   I14RRTGetDvcVendInfo  =$42 ;{Get Device Vendor Info}
const   I14RRTGetDvcStatus    =$43 ;{Get Device Status}
const   I14RRTEnableDevice    =$48 ;{Enable/Resume Device given Dvc Addr}
const   I14RRTDisableDevice   =$49 ;{Disable Device given Dvc Addr}
const   I14RRTResetDevice     =$4A ;{Reset Device given Dvc Addr}
const   I14RRTSuspendDevice   =$4B ;{Suspend Device given Dvc Addr}
const   I14RRTResumeDevice    =$4C ;{Resume Device given Dvc Addr}
const I14RRTConfigClass       =$50 ;{Configuration Class}
const I14RRTConfigingIntf     =$51 ;{;Interface is Being Configured}
const I14RRTConfigIntfDone    =$52 ;{Interface Configuration is Done}

const   I14RRTSetNewConfig    =$58 ;{Set/Change Device Config Value}
const I14RRTInterfaceClass    =$60 ;{Interface Class}
const   I14RRTFindRegIntf     =$62 ;{Look for Registered Interface}
const   I14RRTFindUnRegIntf   =$63 ;{Look for Unregistered Interface}
const   I14RRTRegIntfOwner    =$64 ;{Register as Interface Owner}
const   I14RRTUnRegIntfOwner  =$65 ;{Unregister as Interface Owner}
const   I14RRTIntfDontLook    =$68 ;{Existing Interface Owner Don't Look}
const I14RRTAltIntfClass      =$70 ;{Alternate Interface Class}
const   I14RRTGetAltIntfInfo  =$71 ;{Get Alternate Interface Info}
const I14RRTEndPointClass     =$80 ;{End Point Class}
const I14RRTPacketClass       =$90 ;{Packet Class}
const   I14RRTDoIsoch         =$94 ;{Schedule Isochronous Transaction}
const   I14RRTDoInterruptPer  =$95 ;{Schedule Periodic Interrupt}
const   I14RRTDoControl       =$96 ;{Schedule Control/Setup Request}
const   I14RRTDoBulk          =$97 ;{Schedule Bulk Transaction}
const   I14RRTDoInterrupt1T   =$98 ;{Schedule One-Time Interrupt}
const   I14RRTCloseHandle     =$9C ;{Close/Remove Scheduled Transaction}
const   I14RRTChangeIntPer    =$9D ;{Change Periodicity of Interrupt}
const   I14RRTGetTransStatus  =$9F ;{Get Status of Packet Transaction}
const I14RRTMiscClass         =$A0 ;{Miscellaneous Class}
const   I14RRTLargeCallDone   =$A1 ;{Large (Complicated) Call Complete}
const   I14RRTBeepSpeaker     =$AF ;{Beep the Speaker}
const I14RRTInterHostClass    =$E0 ;{Inter-Host Communication Class}
const   I14RRTCopyNDTable     =$E5 ;{Copy New Device Ownership Table}
const I14RRTInternalClass     =$F0 ;{Host Internal/Troubleshooting Class}



{--------------------------------------------------------------------------}
{Int 14h Flags}
{--------------------------------------------------------------------------}
const I14RFlagIn            =$01 ;{In Direction}
const I14RFlagLowSpeed      =$02 ;{Low-Speed Device}
const I14RFlagHiSpeed       =$04 ;{High-Speed Device}
const I14RFlagNoRetries     =$10 ;{No Auto Retries for Control}
const I14RFlagShortPktOK    =$20 ;{No Retries for Short Packets}
const I14RFlagSpecificFrame =$40 ;{Use Specific Frame Number}
const I14RFlagAddrIsPhys    =$80 ;{Data Address is Physical}

{--------------------------------------------------------------------------}
{Error Codes Returned on Completion of Transfer Descriptor (AX)}
{--------------------------------------------------------------------------}
const TDStsOK             =$0000 ;{ACK Received (TD completed OK / no errors)}
const TDStsNAKReceived    =$0001 ;{NAK Received}
const TDStsStalled        =$0002 ;{TD is Stalled}
const TDStsTimeout        =$0004 ;{TD has timed out (Bulk/Control)}
const TDStsOverDue        =$0008 ;{TD is OverDue (Int/Isoch)}
const TDStsShortPacket    =$0010 ;{TD Short Packet Detected (w/ SPD Enabled)}
const TDStsBabbleDetected =$0020 ;{Babble Detected}
const TDStsCRCTOReceived  =$0040 ;{CRC/TimeOut Error Received}
const TDStsBitStuffError  =$0080 ;{Rx Data contained > 6 ones in a row}
const TDStsDataBuffErr    =$0100 ;{Data Buffer Error}
const TDStsControlSetup   =$1000 ;{Error occurred during Control Setup Stage}
const TDStsLargeCallErr   =$8000 ;{Error during Large Call}

{--------------------------------------------------------------------------}
{Codes Returned by Int 14h Get Host Hardware Info Request (BL)}
{--------------------------------------------------------------------------}
  {Low Nibble (not bit-mapped}
const USBHostTypeUHCI =$01 ;{Universal Host Controller Interface}
const USBHostTypeOHCI =$02 ;{Open Host Controller Interface}
const USBHostTypeEHCI =$03 ;{Enhanced Host Controller Interface (USB 2.0)}

 {High Nibble (not bit-mapped}
const USBBusTypePCI   =$10 ;{Peripheral Component Interconnect}

{--------------------------------------------------------------------------}
{Codes Returned by Int 14h Get Device Info Request (DL)}
{--------------------------------------------------------------------------}
const LowSpeedFlag =$01 ;{Device is Low Speed}

{--------------------------------------------------------------------------}
{Codes Returned by Int 14h Get Device Status Request (CH)}
{--------------------------------------------------------------------------}
const BadDevice        =$01 ;{Bad Device}
const RWakeupSupported =$02 ;{Remote Wakeup Supported}
const RWakeupEnabled   =$04 ;{Remote Wakeup Enabled}
const TestModeEnabled  =$08 ;{Test Mode Enabled}
const BeingConfiged    =$80 ;{Device is currently being Configured}

{--------------------------------------------------------------------------}
{Codes Returned by Int 14h Get Alternate Interface Info Request (CL)}
{--------------------------------------------------------------------------}
const AltIntfSelected =$01 ;{Alternate Interface is Selected}
const AltIntfOwned    =$02 ;{(Alternate) Interface is Owned}

{--------------------------------------------------------------------------}
{Codes Returned by Int 14h Get Device Power Info Request (CL)}
{--------------------------------------------------------------------------}
const DvcPwrInfoSelfPwr  =$01 ;{Device is Self-Powered}
const DvcPwrInfoHubPPP   =$40 ;{Device is Per-Port-Powered Hub}
const DvcPwrInfoDvcIsHub =$80 ;{Device is a Hub}

{--------------------------------------------------------------------------}
{Number of Entries in the New Device Notification table}
{--------------------------------------------------------------------------}
const NDEntries =128;
{joystick things}
 {
;----------------------------------------------------------------------------
;Global
;----------------------------------------------------------------------------
}
  const RptTagUsagePage          =$04{Usage Page};
    const RptGlbUPGenericDeskTop =$01{Generic Desktop};
      const RptGDPointer         =$01{Pointing Device};
      const RptGDMouse           =$02{Mouse};
     {03h =$ Reserved}
      const RptGDJoystick        =$04{Joystick};
      const RptGDGamePad         =$05{GamePad}  ;
      const RptGDKeyboard        =$06{Keyboard}  ;
      const RptGDKeyPad          =$07{KeyPad}     ;
      const RptGDMultiAxisCtl    =$08{Multi-Axis Controller};
       {09h - 2Fh =$ Reserved}
      const RptGDXAxis           =$30{X-axis}                 ;
      const RptGDYAxis           =$31{Y-axis}                  ;
      const RptGDZAxis           =$32{Z-axis}                   ;
      const RptGDRotateX         =$33{Rotation around X-axis}    ;
      const RptGDRotateY         =$34{Rotation around Y-axis}     ;
      const RptGDRotateZ         =$35{Rotation around Z-axis}      ;
      const RptGDSlider          =$36{Slider}                       ;
      const RptGDDial            =$37{Dial}                          ;
      const RptGDWheel           =$38{Wheel}                          ;
      const RptGDHatSwitch       =$39{Hat-Switch}                      ;
      const RptGDCountedBuff     =$3A{Counted Buffer}                   ;
      const RptGDByteCount       =$3B{Byte Count}                        ;
      const RptGDMotionWakeup    =$3C{Wakeup on Motion}                   ;
      const RptGDStart           =$3D{Start}                               ;
      const RptGDSelect          =$3E{Select}                               ;
      {3Fh Reserved}
      const RptGDVectorX         =$40{X-Axis Vector}                          ;
      const RptGDVectorY         =$41{Y-Axis Vector};
      const RptGDVectorZ         =$42{Z-Axis Vector  };
      const RptGDVectorBRX       =$43{X-Axis Vector, Relative to Body};
      const RptGDVectorBRY       =$44{Y-Axis Vector, Relative to Body} ;
      const RptGDVectorBRZ       =$45{Z-Axis Vector, Relative to Body}  ;
      const RptGDVectorNoD       =$46{Non-Directional Tempurature,etc}   ;
      {47h =$ ??}
      const RptGDResMult         =$48{Resolution Multiplier}               ;
      {49h-7Fh =$ Reserved}
      const RptGDSysCtl          =$80{System Control}                        ;
      const RptGDSysPowerDown    =$81{System Power Down}                      ;
      const RptGDSysSleep        =$82{System Sleep}                            ;
      const RptGDSysWakeUp       =$83{System Wake Up}                           ;
      const RptGDSysMenuContext  =$84{System Menu Context}                       ;
      const RptGDSysMenuMain     =$85{System Menu Main}                           ;
      const RptGDSysMenuApp      =$86{System Menu Application}                     ;
      const RptGDSysMenuHelp     =$87{System Menu Help}       ;
      const RptGDSysMenuExit     =$88{System Menu Exit}        ;
      const RptGDSysMenuSelect   =$89{System Menu Select}       ;
      const RptGDSysMenuRight    =$8A{System Menu Right}         ;
      const RptGDSysMenuLeft     =$8B{System Menu Left}           ;
      const RptGDSysMenuUp       =$8C{System Menu Up}              ;
      const RptGDSysMenuDown     =$8D{System Menu Down}             ;
      const RptGDSysColdStart    =$8E{System Cold Restart}           ;
      const RptGDSysWarmStart    =$8F{System Warm Restart}            ;
      const RptGDDPadUp          =$90{D-Pad Up}                        ;
      const RptGDDPadDown        =$91{D-Pad Down}                       ;
      const RptGDDPadRight       =$92{D-Pad Right}                       ;
      const RptGDDPadLeft        =$93{D-Pad Left}                         ;
      {94h - 9Fh =$ Reserved}



      const RptGDSysDock         =$A0{System Dock};
      const RptGDSysUndock       =$A1{System Undock};
      const RptGDSysSetup        =$A2{System Setup}  ;
      const RptGDSysBreak        =$A3{System Break}   ;
      const RptGDSysDbgBrk       =$A4{System Debugger Break};
      const RptGDSysAppBrk       =$A5{Application Break}     ;
      const RptGDSysAppDbgBrk    =$A6{Application Debugger Break};
      const RptGDSysMute         =$A7{System Speaker Mute}        ;
      const RptGDSysHibernate    =$A8{System Hibernate}            ;
      {A9h - AFh =$ Reserved}
      const RptGDSysDispInvt     =$B0{System Display Invert}         ;
      const RptGDSysDispInt      =$B1{System Display Internal}        ;
      const RptGDSysDispExt      =$B2{System Display External}         ;
      const RptGDSysDispBoth     =$B3{System Display Both}              ;
      const RptGDSysDispDual     =$B4{System Display Dual}               ;
      const RptGDSysDispTgl      =$B5{System Display Toggle };
      const RptGDSysDispSwap     =$B6{System Display Swap };
      const RptGDSysDispAuto     =$B7{System Display LCD Autoscale};
      {B8h - FFFFh =$ Reserved}

    const RptGlbUPSimulationCtl  =$02{Simulation Controls}    ;
      const RptSimFlightSim      =$01{Flight Simulation Device};
      const RptSimAutoSim        =$02{Automobile Simulation Device};
      const RptSimTankSim        =$03{Tank Simulation Device}       ;
      const RptSimSpaceShipSim   =$04{Spaceship Simulation Device}   ;
      const RptSimSubmarineSim   =$05{Submarine Simulation Device}    ;
      const RptSimSailingSim     =$06{Sailing Simulation Device}       ;
      const RptSimMotorcycleSim  =$07{Motorcycle Simulation Device}     ;
      const RptSimSportsSim      =$08{Sports Simulation Device}          ;
      const RptSimAirplaneSim    =$09{Airplane Simulation Device}         ;
      const RptSimHelicopterSim  =$0A{Helicopter Simulation Device}        ;
      const RptSimMagicCarpetSim =$0B{Magic Carpet Simulation Device}       ;
      const RptSimBicycleSim     =$0C{Bicycle Simulation Device}             ;
      {0Dh - 1Fh =$ Reserved}
      const RptSimFlightCtlStick =$20{Flight Control Stick};
      const RptSimFlightStick    =$21{Flight Stick};
      const RptSimCyclicCtl      =$22{Cyclic Control};
      const RptSimCyclicTrim     =$23{Cyclic Trim}    ;
      const RptSimFlightYoke     =$24{Flight Yoke}     ;
      const RptSimTrackCtl       =$25{Track Control}    ;
      {26h - AFh =$ Reserved}
      const RptSimAileron        =$B0{Aileron}           ;
      const RptSimAileronTrim    =$B1{Aileron Trim}       ;
      const RptSimAntiTorqueCtl  =$B2{Anti-Torque Control} ;
      const RptSimAutoPilot      =$B3{Autopilot Enable}     ;
      const RptSimChaffRelease   =$B4{Chaff Release}         ;
      const RptSimCollectiveCtl  =$B5{Collective Control}     ;
      const RptSimDiveBrake      =$B6{Dive Brake}              ;
      const RptSimElecCtrMsrs    =$B7{Electronic Countermeasures};
      const RptSimElevator       =$B8{Elevator}                    ;
      const RptSimElevatorTrim   =$B9{Elevator Trim}              ;
      const RptSimRudder         =$BA{Rudder}                       ;
      const RptSimThrottle       =$BB{Throttle}                      ;
      const RptSimFlightComm     =$BC{Flight Communications}          ;
      const RptSimFlareRelease   =$BD{Flare Release}                   ;
      const RptSimLandingGear    =$BE{Landing Gear}                     ;
      const RptSimToeBrake       =$BF{Toe Brake}                          ;
      const RptSimTrigger        =$C0{Trigger}                             ;
      const RptSimWeaponsArm     =$C1{Weapons Arm}   ;
      const RptSimWeaponsSelect  =$C2{Weapons Select} ;
      const RptSimWingFlaps      =$C3{Wing Flaps}      ;
      const RptSimAccelerator    =$C4{Accelerator}      ;
      const RptSimBrake          =$C5{Brake}             ;
      const RptSimClutch         =$C6{Clutch}             ;
      const RptSimShifter        =$C7{Shifter}             ;
      const RptSimSteering       =$C8{Steering}             ;
      const RptSimTurretDir      =$C9{Turret Direction}      ;
      const RptSimBarrelElev     =$CA{Barrel Elevation}       ;
      const RptSimDivePlane      =$CB{Dive Plane}              ;
      const RptSimBallast        =$CC{Ballast}         ;
      const RptSimBicycleCrank   =$CD{Bicycle Crank}    ;
      const RptSimHandlebars     =$CE{Handle Bars}       ;
      const RptSimFrontBrake     =$CF{Front Brake}        ;
      const RptSimRearBrake      =$D0{Rear Brake}          ;
      {D1h - FFFFh =$ Reserved}

    const RptGlbUPVRCtl          =$03{Virtual Reality? Controls};
    const RptGlbUPSportCtl       =$04{Sport Controls}   ;
    const RptGlbUPGameCtl        =$05{Game Controls}     ;
      const RptGame3DCtl         =$01{3D game Controller} ;
      const RptGamePinball       =$02{Pinball Device}      ;
      const RptGameGun           =$03{Gun Device}           ;
      {04h - 1Fh =$ Reserved}
      const RptGamePOV           =$20{Point-of-View}         ;
      const RptGameTurn          =$21{Turn Right/Left}        ;
      const RptGamePitch         =$22{Pitch Right/Left}        ;
      const RptGameRoll          =$23{Roll Forward/Backward}    ;
      const RptGameMoveX         =$24{Move Right/Left}           ;
      const RptGameMoveY         =$25{Move Forward/Backward}       ;
      const RptGameMoveZ         =$26{Move Up/Down}                 ;
      const RptGameLeanX         =$27{Lean Right/Left};
      const RptGameLeanY         =$28{Lean Forward/Backward};
      const RptGamePOVHeight     =$29{Height of Point-of-View};
      const RptGameFlipper       =$2A{Flipper}                 ;
      const RptGameFlipper2      =$2B{Secondary Flipper}        ;
      const RptGameBump          =$2C{Bump}                      ;
      const RptGameNewgame       =$2D{New Game}                   ;
      const RptGameShootball     =$2E{Shoot ball}                  ;
      const RptGamePlayer        =$2F{Player}                       ;
      const RptGameGunBolt       =$30{Gun Bolt}                       ;
      const RptGameGunClip       =$31{Gun Clip}             ;
      const RptGameGunSelector   =$32{Gun Selector}        ;
      const RptGameGunSingleShot =$33{Gun Single Shot}       ;
      const RptGameGunBurst      =$34{Gun Burst Shot}         ;
      const RptGameGunAutomatic  =$35{Gun Automatic Shot}      ;
      const RptGameGunSafety     =$36{Gun Safety}               ;
      const RptGamePadFireJump   =$37{GamePad Fire/Jump}         ;
      {38h =$ ???}
      const RptGamePadTrigger    =$39{GamePad Trigger}             ;

{06h = ??}
    const RptGlbUPKeyboard       =$07;{Keyboard/Keypad (Usage Type }
    const RptGlbUPLED            =$08;{LEDs (Light Emitting Diodes) }
    const RptGlbUPButton         =$09;{Buttons}
    const RptGlbUPOrdinal        =$0A;{Ordinal }
    const RptGlbUPConsumerDvc    =$0C;{Consumer Devices}
    const RptGlbUPPID            =$0F;{Physical Interface Dev FFB }

  const RptTagLogicalMin         =$14;{Logical Minumum}
  const RptTagLogicalMax         =$24;{Logical Maximum }
  const RptTagPhysicalMin        =$34;{Physical Minimum}
  const RptTagPhysicalMax        =$44;{Physical Maximum}
  const RptTagUnitExponent       =$54;{Unit Exponent (base 10)}
  const RptTagUnit               =$64;{Units}

  const RptTagReportSize         =$74;{Size of Report Field in (bits)}
  const RptTagReportID           =$84;{Report ID}
  const RptTagReportCount        =$94;{Report Count}

const  RptTagPush              =$A4 ;{Push Global State Table onto the Stack}
const  RptTagPop               =$B4 ;{Pop Global State Table from the Stack   }



  {local jstik}

const  RptTagUsage              =$08 ;{Usage}
const  RptTagUsageMin           =$18 ;{Usage Minimum}
const  RptTagUsageMax           =$28 ;{Usage Maximum}
const  RptTagDesignatorIndex    =$38; {Designator Index (Body Part)}
const  RptTagDesignatorMin      =$48 ;{Designator Minimum}
const  RptTagDesignatorMax      =$58 ;{Designator Maximum}
const  RptTagStringIndex        =$78 ;{String Index}
const  RptTagStringMin          =$88 ;{String Minimum}
const  RptTagStringMax          =$98 ;{String Maximum}
const  RptTagDelimiter          =$0A8 ;{1 = Open Set, 2 = Close Set}


 {
;==============================================================================
;USBJSTIK Related (Program-specific)
;==============================================================================
}

const  MinCoord  =   1 ;{Value returned when coordinate is Up/Left}
const  DefCenter =  50 ;{Default Value returned when coordinate is Centered}
const  MinCenter =  10 ;{Minimum Center Coordinate allowed}
const  MaxCenter = 200 ;{Maximum Center Coordinate allowed }
{
;
;STRUCTURES
;
 }

 {;==============================================================================
;USB/Joystick-Related
;==============================================================================
}
 { ;----------------------------------------------------------------------------
  ;Structure to Translate Raw USB Data into individual Entities
  ;----------------------------------------------------------------------------}

      {SRRequestType}
      const  SRRTOut           =$00;{0=Out (Host to Device)}
      const  SRRTIn            =$80;{1=In (Device to Host)}
      const  SRRTTypeMask      =$60;{Mask for Type}
      const  SRRTTypeStandard  =$00;{Type 0 = Standard}
      const  SRRTTypeClass     =$20;{Type 1 = Class}
      const  SRRTTypeVendor    =$40;{Type 2 = Vendor}
      const  SRRTRecipientMask =$1F;{Mask for Recipient Type}
      const  SRRTRecipDevice   =$00;{Recipient Type 0 = Device}
      const  SRRTRecipInterface=$01;{Recipient Type 1 = Interface}
      const  SRRTRecipEndPoint =$02;{Recipient Type 2 = EndPoint}
      const  SRRTRecipOther    =$03;{Recipient Type 3 = Other}
     {SRRequest}
      const  SRRQGetStatus      = 0 ;{Request  0 = Get Status}
      const  SRRQClearFeature   = 1 ;{Request  1 = Clear Feature}
      const  SRRQGetState       = 2 ;{Request  2 = Get State}
      const  SRRQSetFeature     = 3 ;{Request  3 = Set Feature}
      const  SRRQSetAddress     = 5 ;{Request  5 = Set Address}
      const  SRRQGetDescriptor  = 6 ;{Request  6 = Get Descriptor}
      const  SRRQSetDescriptor  = 7 ;{Request  7 = Set Descriptor}
      const  SRRQGetConfig      = 8 ;{Request  8 = Get Configuration}
      const  SRRQSetConfig      = 9 ;{Request  9 = Set Configuration}
      const  SRRQGetAltInterface=10 ;{Request 10 = Get Alternate Interface}
      const  SRRQSetAltInterface=11 ;{Request 11 = Set Alternate Interface}
      const  SRRQSynchFrame     =12 ;{Request 12 = Synch Frame}
      CTNone              =$00 ;{Empty Entry}
      CTButton            =$01 ;{Button}
      CTDPad              =$02 ;{D-Pad or 8-Way Hat Switch}
      CTSlider            =$03 ;{Slider (Loose Axis)}
      CTThrottle          =$04 ;{Throttle (Self-Closing Axis)}
      CTAxis              =$05 ;{Standard Axis (Self-Centering Axis)}
      DIFlagInUse         =$01 ;{This entry currently being used?}
{
  ;----------------------------------------------------------------------------
  ;Device Request is a structure containing data required by a USB Setup Packet
  ;----------------------------------------------------------------------------
  }

Type  SetupRequest = Record     {;Structure for a Standard Setup Pkt}
    SRRequestType          :byte;    {;Request Type}
    SRRequest              :byte;    {;Specific Request}
    SRValue                :word;    {;Value depends on Request Type}
    SRIndex                :word;    {;Index depends on Request Type}
    SRLength               :word;    {;Length of Data (if there is Data)}
   END;
const SetupRequestSize = sizeof(SetupRequest);

 {
  ;----------------------------------------------------------------------------
  ;Format of data returned by a Get Device Descriptor
  ;----------------------------------------------------------------------------
}


Type
PDeviceDescriptor = ^DeviceDescriptor;
DeviceDescriptor   = Record    {Structure for a Device Descriptor}
    DDLength            :byte   ;{Size of Descriptor in bytes}
    DDDescrType         :byte ;{DescrTypeDevice}
    DDUSBRelease        :word  ;{USB Compliance  bcd (0210h=v2.10)}
    DDDvcClass          :byte   ;{Device Class (defined by USB-IF)}
    DDDvcSubClass      :byte   ;{Device SubClass (defined by USB-IF)}
    DDDvcProtocol       :byte   ;{Device Protocol (defined by USB-IF)}
    DDMaxPktSize        :byte   ;{Max Packet Size for EndPoint 0}
                              {  MUST be 8, 16, 32, or 64}
    DDVendorID          :word   ;{Vendor ID (defined by USB-IF)}
    DDProductID         :word   ;{Product ID (defined by manufacturer)}
    DDDeviceRelease     :word   ;{Device Release Number (bcd)}
    DDManufacturerIndx  :byte   ;{Index of Manufacturer String}
    DDProductIndx       :byte   ;{Index of Product String}
    DDSerialNumberIndx  :byte   ;{Index of Serial Number String}
    DDNumConfigs        :byte   ;{Number of possible Configurations}
   END;
const  DeviceDescriptorSize = sizeof (DeviceDescriptor);

 {
  ;----------------------------------------------------------------------------
  ;Format of data returned by a Get Interface Descriptor
  ;----------------------------------------------------------------------------
}
type  InterfaceDescriptor   =record     {Structure for an Interface Descr}
    IDLength               :byte    ;{Size of Descriptor in :bytes}
    IDDescrType            :byte ;{DescrTypeInterface}
    IDInterfaceNumber      :byte    ;{Interface Number (0-based Index)}
    IDAlternateSetting     :byte    ;{Value used to select this alternate}
                                  {  setting for the Interface Number}
    IDNumEndPoints         :byte    ;{Number of Interfaces, excl 0}
    IDInterfaceClass       :byte    ;{Interface Class (defined by USB-IF)}
    IDInterfaceSubClass    :byte    ;{Interface SubClass (def by USB-IF)}
    IDInterfaceProtocol    :byte    ;{Interface Protocol (def by USB-IF)}
    IDInterfaceIndx        :byte    ;{Index of Interface String}
   END;

   {
  ;----------------------------------------------------------------------------
  ;Format of data returned by a Get EndPoint Descriptor
  ;----------------------------------------------------------------------------
  }

type  EndPointDescriptor    =record    { =recordture for an EndPoint Descr}
    EDLength               :byte    ;{Size of Descriptor in bytes}
    EDDescrType            :byte ;{DescrTypeEndPoint}
    EDEndPointNumber       :byte    ;{EndPoint Number EP's)}
      {Bits 6:4 = Reserved (0)}

    EDAttributes           :byte    ;{EndPoint attributes}
      {Bits 7:6 = Reserved (0)}

    EDMaxPktSize           :word    ;{Max Packet Size EndPoint can handle}
    EDPollInterval         :byte    ;{Polling Interval for Data Transfers}
    {The following two bytes only appear in some Isochronous Applications}
    EDRefreshRate          :byte    ;{Refresh Rate (1-9, power of 2 mS)}
    EDSynchEndPoint        :byte    ;{Synchronization EndPoint}
   END;
const  EndPointDescriptorSize = sizeof(EndPointDescriptor);

  {----------------------------------------------------------------------------}
{  ;{Format of data returned by an HID (Human Interface Device) Descriptor        }
  {----------------------------------------------------------------------------}
type  HIDDescriptor       =record     {=recordture for an HID Descriptor}
    HIDDLength           :byte    ;{Size of Descriptor in bytes}
    HIDDDescrType        :byte ;{DescrTypeHID]}
    HIDDClassRelease     :word    ;{HID Class Release Spec (BCD)}
    HIDDCountryCode      :byte    ;{Country Code}
                                {0 = None/NA, 21h = US}
    HIDDNumClasses       :byte    ;{Number of Class Descriptors}
    HIDDDescriptorType   :byte    ;{Type of Class Descriptor}
                                {DescrTypeHIDReport (22h) or}
                                {DescrTypeHIDPhysical (23h)}
    HIDDDescriptorLength :word    ;{Length of Class Descriptor}
     {Repeat Type and Length for each Class Descriptor}
   END;
const  HIDDescriptorSize = 9;

 {
  ;----------------------------------------------------------------------------
  ;Structure to Translate Raw USB Data into individual Entities
  ;----------------------------------------------------------------------------
}

Type
ControlStruc = Record
    ControlType            :byte ;{Type of Control}
    ControlQty             :byte ;{Number of Controls in a row (no }
    ControlOffset          :byte ;{Offset (in Bits) to beginning of }
    ControlNumBits         :byte ;{Number of bits of Data per Control}
    ControlMin             :word ;{Minimum Control value}
    ControlMax             :word ;{Maximum Control value}
end;

 {
  ;----------------------------------------------------------------------------
  ;Structure to store data for each USB Joystick
  ;----------------------------------------------------------------------------
}

Type DeviceInfoStruc = Record{Structure to Store Device Data}
    DIFlags           :byte   ;{Misc Yes/No Flags}
    DIHostIndex       :byte   ;{Host Index}
    DIDvcAddress      :byte   ;{Device Address}
    DIEndPoint        :byte   ;{End Point Number}
    DIInterfaceNum    :byte   ;{Interface Number}
    DIFiller          :byte   ;{To align at even addresses}
    DIControlsData    :byte   ;{(ControlStrucSize*MaxControls) DUP (0)}
                             {Controls Translation Data}
    DIReportID        :byte   ;{Report ID (if needed)}
    DIReportIDData    :byte   ;{Report ID from Data (if provided)}
                             {  MUST IMMEDIATELY precede DIRawData!!!}
{    DIRawData        :byte 8 DUP (0) ;{Raw Device Data}
    DIRawData         :byte   ;{Raw Device Data}
    DIRegHandle       :word   ;{Handle Number of Owner Registry}
    DIIntHandle       :word   ;{Handle number of Periodic Interrupt}
end;

 {
  ;----------------------------------------------------------------------------
  ;Format of data returned by a Get Configuration Descriptor
  ;----------------------------------------------------------------------------
}
Type  ConfigDescriptor  =   record     {Structure for a Config Descriptor}
    CDLength              :byte    ;{Size of Descriptor in bytes}
    CDDescrType           :byte ;{DescrTypeConfig}
    CDTotalLength         :word    ;{Total length of data returned for}
                                 {  this configuration (ALL data)}
    CDNumInterfaces       :byte    ;{Number of Interfaces in this }
    CDConfigValue         :byte    ;{Value to use in SetRequest to}
                                 {  set this configuration}
    CDConfigurationIndx   :byte    ;{Index of Configuration String}
    CDAttributes          :byte    ;{Configuration Attributes}
    CDMaxBusPower         :byte    ;{Maximum Power Consumption FROMBUS}

   END;
const  ConfigDescriptorSize =sizeof(ConfigDescriptor);

 {
  ;----------------------------------------------------------------------------
  ;Structure to keep track of Translations between USB Controls and
  ;  "standard" Joystick Controls
  ;We'll need one of these Structures for each Analog Joystick Value
  ;  (AX, AY, BX, BY, G, B1-B15)
  ;We originally tried to "automate" things more by trying ignore/keep
  ;  "skipping" controls, but it turned out to be more confusing and
  ;  less flexible, especially for "complicated" joysticks.  Can't think of
  ;  a good way to provide mapping facilities, short of a GUI.  A GUI itself
  ;  would be EXTREMELY complicated, since we may or may not be dealing with
  ;  multiple joysticks, with different nubmers and types of controls.
  ;If we ever get into Force Feedback, we're really talking about complicated!
  ;----------------------------------------------------------------------------
}

Type XlatStruc = Record
    XlatJIndex   :byte ;{Joystick Index Number (0-7)}
    XlatCType    :byte ;{Control Type (Axis, Button, etc., 255 = N/A)}
    XlatCIndex   :byte ;{Control Index (0-100, 255 = N/A)}
    XlatCIndex2  :byte ;{Control Index #2 (-1 if N/A)}
end;


{  ;----------------------------------------------------------------------------
  ;This structure keeps track of Bad (incompatible) Devices
  ;----------------------------------------------------------------------------}
Type BadDeviceStruc = Record
    BDFlags            :byte  ;{Misc Yes/No Flags}
    BDInterfaceNum     :byte  ;{Interface Number of Bad Device}
    BDHostIndex        :byte  ;{Host Index of Bad Device}
    BDDvcAddress       :byte  ;{Device Address of Bad Device}
    BDFiller           :byte  ;{To align data at even addresses}
    BDNewDeviceStage   :byte  ;{Bad Device Stage}
    BDNewDeviceError   :word  ;{Bad Device Error Code}
end;
 {
  ;----------------------------------------------------------------------------
  ;This is the format for a request sent to Int 14h to Send/Receive Data
  ;It contains the type of request, etc.
  ;----------------------------------------------------------------------------
}
Type
PInt14RequestStruc = ^Int14RequestStruc;
Int14RequestStruc = Record
I14RRequestType:byte;     {//Request Type}
I14RFlags:byte;           {//Bit-level Flags}
I14RHostIndex:byte;       {//Host Index}
I14RDeviceAddress:byte;   {//USB Device Address}
                          {//  Also I14RHubAddress}
I14REndPoint:byte;        {//End Point}
                                     {//  Also I14RHubPort}
                                     {//  Also I14RAltInterface}
I14RConfigValue:byte;     {//Configuration Value}
                                     {//  Also I14RCloseID}
I14RInterfaceNum:byte;    {//Interface Number}
I14RSearchIndex:byte;     {//Search Index}
I14RVendorID:word;        {//Vendor ID}
I14RProductID:word;       {//Product ID}
I14RDvcClass:byte;        {//Device Class}
I14RDvcSubClass:byte;     {//Device SubClass}
I14RDvcProtocol:byte;     {//Device Protocol}
I14RIntfClass:byte;       {//Interface Class}
I14RIntfSubClass:byte;    {//Interface SubClass}
I14RIntfProtocol:byte;    {//Interface Protocol}
I14RRequestHandle:word;   {//Request Handle Number}
I14RPeriodicity:word;     {//Interrupt Periodicity/Duration}
                                     {//  Also I14RBeepFrequency}
I14RTimeout:word;         {//Transaction Timeout Value}
I14RDataAddrOff:word;     {//Data Address Offset}
I14RDataAddrSeg:word;     {//Data Address Segment}
I14RDataSize:word;        {//Size of Data (bytes)}

I14RCallBackAddrOff:word; {//Call Back Address Offset (IP)}
                                     {//  Also I14RLargeCallRtnCode}
I14RCallBackAddrSeg:word; {//Call Back Address Segment (CS)}

I14RUserPktID:word;       {//User Packet ID}
{start of 8 byte setup packet}
I14RSetupReqType:byte;    {//Setup Packet Request Type}
I14RSetupReq:byte;        {//Setup Packet Request Code}
I14RSetupValue:word;      {//Setup Packet Value}
I14RSetupIndex:word;      {//Setup Packet Index}
I14RSetupLength:word;     {//Setup Packet Length}
{end of packet}
I14RFrameTiming:word;     {//Frame Timing Value (def = 12000)}
                                    { //  Also I14RFrameIndex}
I14RIsochSchedOff:word;   {//Isochronous Schedule Table Offset}
I14RIsochSchedSeg:word;   {//Isochronous Schedule Table Segment}
I14RFiller1:word;         {//Fillers to equal 64 bytes}
I14RFiller2:word;
I14RFiller3:word;
I14RFiller4:word;
I14RFiller5:word;
I14RFiller6:word;
I14RFiller7:word;
end;


implementation

end.
